from Cookie import SimpleCookie

from Client import call as no_proxy_call

HEADER = 0

def call(url,method=None,username=None,password=None,timeout=None,headers={},REQUEST=None,**kw):
    # REQUEST
    if REQUEST is not None:
        environ = REQUEST.environ
        # method
        if method is None and environ.has_key('REQUEST_METHOD'):
            method = environ['REQUEST_METHOD']
            # POST - update with form data
            if method == 'POST':
                kw.update(REQUEST.form)
        # headers - Cookie
        if not headers.has_key('Cookie') and environ.has_key('HTTP_COOKIE'):
            headers['Cookie'] = environ['HTTP_COOKIE']
        # headers - User-Agent
        if not headers.has_key('User-Agent') and environ.has_key('HTTP_USER_AGENT'):
            headers['User-Agent'] = environ['HTTP_USER_AGENT']
        # headers - Host
        host = environ.get('HTTP_X_HOST',environ.get('HTTP_HOST',None))
        if not headers.has_key('Host') and host:
            headers['Host'] = host
        # headers - REMOTE_ADDR
        remote_addr = environ.get('REMOTE_ADDR_X',environ.get('REMOTE_ADDR',None))
        if not headers.has_key('REMOTE-ADDR') and remote_addr:
            headers['REMOTE-ADDR'] = remote_addr
        # headers - REMOTE_HOST
        remote_host = environ.get('REMOTE_HOST_X',environ.get('REMOTE_HOST',None))
        if not headers.has_key('REMOTE-HOST') and remote_host:
            headers['REMOTE-HOST'] = remote_host
    
    response = apply(no_proxy_call,(url,method,username,password,timeout,headers),kw)

    # RESPONSE
    if REQUEST is not None:
        # cookies
        cookies = SimpleCookie()
        for cookie in response[HEADER].getallmatchingheaders('Set-Cookie'):
            cookies.load(cookie)
        for cookie in cookies.keys():
            attribs = {}
            if cookies[cookie].has_key('expires'):
                attribs.update({'expires':cookies[cookie]['expires']})
            REQUEST.RESPONSE.setCookie(cookie,cookies[cookie].value,attribs)
        # redirect
        if response[HEADER].has_key('location'):
            REQUEST.RESPONSE.setBase(response[HEADER]['location'])
            raise 'Redirect', response[HEADER]['location']

    return response
